﻿using Kivii.Linq.Test.Entities;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Linq.Test.Samples
{
    public class JoinTest
    {
        public IDbConnection Connection { get; set; }
        public void JoinTwoEntities()
        {
            Connection.InitEntityType<Customer>();
            Connection.InitEntityType<Contact>();
            Connection.Delete<Customer>(o => o.Status > 0);
            Connection.Delete<Contact>(o => o.Status > 0);
            var newCustomer = new Customer();
            newCustomer.FullName = "南京凯佩软件有限公司";
            newCustomer.Address = "南京万达茂";
            Connection.Insert(newCustomer);
            var newContact = new Contact();
            newContact.FullName = "施晓雨";
            newContact.MobilePhone = "13951678284";
            newContact.CustomerKvid = newCustomer.Kvid;
            Connection.Insert(newContact);
            newContact = new Contact();
            newContact.FullName = "任天宇";
            newContact.MobilePhone = "139000000";
            newContact.CustomerKvid = newCustomer.Kvid;
            Connection.Insert(newContact);

            var query = Connection.From<Contact>()
                .LeftJoin<Customer>((contact, customer) => contact.CustomerKvid == customer.Kvid)
                .Select<Contact, Customer>((contact, customer) => new { T=Sql.AllFields(contact), CustomerFullName = customer.FullName,CustomerAddress=customer.Address })
                .Where<Contact>(contact=>contact.FullName.Contains("施"))//在两个不同表中组合查询条件
                .And<Customer>(customer=>customer.FullName.Contains("南京"));//在两个不同表中组合查询条件
            
            var rtns = Connection.Select<ContactEx>(query);
            var myContact = rtns[0];
            Console.WriteLine(Connection.GetLastSql());
            Console.WriteLine($"CustomerFullName:{myContact.CustomerFullName},FullName:{myContact.FullName},MobilePhone:{myContact.MobilePhone}");
        }
    }
}
